;------- TASM ASM mnemonics. -------
; Compile this file using:
; Set TASMOPTS = -b
; tasm -80 ThisCode.tas MyBinary.BIN
;-----------------------------------
; Zx81 Program name: VB81 XuR [CENTIPEDE.P] : SAVE"CENTIPEDE" Line 9000
; REM   line   name: D=30125/31149 : H=75AD/79AD

#define ORG  .org       ; TASM cross-assembler definitions
#define equ  .equ
;-----------------------------------

;------------------------------------
;-Basic sub-routine entry.          -
;+----------------------------------+
; Lb7810  ;  <- USR Basic Enty.
; Lb7871  ;  <- USR Basic Enty.
; Lb78AD  ;  <- USR Basic Enty.
;+----------------------------------+

;------- Rom and Ram Symbols -------
RAM_D_FILE equ $400C
RAM_LAST_K equ $4025
STACK_A equ $151D
RAM_SEED equ $4032
STACK_BC equ $1520
FIND_INT equ $0EA7


ORG $75AD ; [@30125/@h75AD]
Lb75AD:
	LD B,$00 
	LD D,$00 
	LD HL,$0000 
	ADD HL,DE 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,DE 
	ADD HL,BC 
	PUSH DE 
	LD DE,(RAM_D_FILE) ; GET D-FILE
	ADD HL,DE 
	INC HL 
	POP DE 
	RET ; ==========================

Lb75C5:
	PUSH HL 
	CALL Lb75AD ; [30125]
	LD A,(HL) 
	POP HL 
	CP $00 ; [0]
	JR Z, Lb75D2 ; [$75D2:30162]
	LD A,$01 
	RET ; ==========================

Lb75D2:
	XOR A 
	RET ; ==========================

Lb75D4:
	LD A,($75A8) 
	LD HL,$7530 
	CP $00 ; [0]
	JR Z, Lb75E5 ; [$75E5:30181]
	LD DE,$0006 
	LD B,A 
Lb75E2:
	ADD HL,DE 
	DJNZ Lb75E2 ; [$75E2:30178]
Lb75E5:
	LD ($75A9),HL 
	INC HL 
	INC HL 
	INC HL 
	INC HL 
	INC HL 
	LD A,(HL) 
	CP $00 ; [0]
	JP Z, Lb7623 ; [30243]
	DEC HL 
	DEC HL 
	LD A,(HL) 
	CP $01 ; [1]
	JP Z, Lb765E ; [30302]
	JP Lb7636 ; [30262]
Lb75FE:
	LD HL,($75A9) 
	LD C,(HL) 
	INC HL 
	LD E,(HL) 
	CALL Lb75AD ; [30125]
	LD (HL),$00 
	LD HL,($75A9) 
	LD A,(HL) 
	INC HL 
	INC HL 
	ADC A,(HL) 
	DEC HL 
	DEC HL 
	LD (HL),A 
	LD C,A 
	INC HL 
	LD A,(HL) 
	INC HL 
	INC HL 
	ADD A,(HL) 
	DEC HL 
	DEC HL 
	LD (HL),A 
	LD E,A 
	CALL Lb75AD ; [30125]
	LD (HL),$34 
	RET ; ==========================

Lb7623:
	LD A,($75A8) 
	INC A 
	LD ($75A8),A 
	CP $14 ; [20-"="]
	JP NZ, Lb75D4 ; [30164]
	SUB A 
	LD ($75A8),A 
	JP Lb75D4 ; [30164]
Lb7636:
	DEC HL 
	LD A,(HL) 
	DEC HL 
	LD E,(HL) 
	DEC HL 
	ADD A,(HL) 
	LD C,A 
	CALL Lb75C5 ; [30149]
	CP $00 ; [0]
	JP Z, Lb75FE ; [30206]
	INC E 
	LD C,(HL) 
	CALL Lb75C5 ; [30149]
	CP $01 ; [1]
	JP Z, Lb76DC ; [30428]
	INC HL 
	INC HL 
	INC HL 
	LD (HL),$01 
	DEC HL 
	LD A,(HL) 
	LD (HL),$00 
	INC HL 
	INC HL 
	LD (HL),A 
	JP Lb75FE ; [30206]
Lb765E:
	DEC HL 
	DEC HL 
	DEC HL 
	LD A,(HL) 
	CP $01 ; [1]
	JP Z, Lb76B6 ; [30390]
	CP $1E ; [30-"2"]
	JP Z, Lb76B6 ; [30390]
	INC HL 
	LD E,(HL) 
	INC HL 
	INC HL 
	INC HL 
	ADD A,(HL) 
	LD C,A 
	CALL Lb75C5 ; [30149]
	CP $01 ; [1]
	JP Z, Lb7684 ; [30340]
	LD A,(HL) 
	DEC HL 
	LD (HL),$00 
	DEC HL 
	LD (HL),A 
	JP Lb75FE ; [30206]
Lb7684:
	INC C 
	INC C 
	LD A,(HL) 
	CP $01 ; [1]
	JR NZ, Lb768D ; [$768D:30349]
	DEC C 
	DEC C 
Lb768D:
	CALL Lb75C5 ; [30149]
	JP Lb76F7 ; [30455]
	NOP 
Lb7694:
	LD A,(HL) 
	DEC HL 
	LD (HL),$00 
	DEC HL 
	LD (HL),$01 
	CP $01 ; [1]
	JR NZ, Lb76A1 ; [$76A1:30369]
	DEC (HL) 
	DEC (HL) 
Lb76A1:
	JP Lb75FE ; [30206]
Lb76A4:
	DEC HL 
	DEC HL 
	DEC HL 
	LD E,(HL) 
	INC E 
	DEC HL 
	LD C,(HL) 
	CALL Lb75C5 ; [30149]
	CP $01 ; [1]
	JP Z, Lb76DC ; [30428]
	JP Lb75FE ; [30206]
Lb76B6:
	LD C,(HL) 
	INC HL 
	LD E,(HL) 
	INC HL 
	INC HL 
	INC HL 
	LD A,(HL) 
	INC C 
	CP $01 ; [1]
	JR NZ, Lb76C4 ; [$76C4:30404]
	DEC C 
	DEC C 
Lb76C4:
	CALL Lb75C5 ; [30149]
	CP $01 ; [1]
	JP Z, Lb76A4 ; [30372]
	LD A,(HL) 
	DEC HL 
	LD (HL),$00 
	DEC HL 
	LD (HL),$01 
	CP $01 ; [1]
	JR NZ, Lb76D9 ; [$76D9:30425]
	DEC (HL) 
	DEC (HL) 
Lb76D9:
	JP Lb75FE ; [30206]
Lb76DC:
	LD HL,($75A9) 
	LD C,(HL) 
	INC HL 
	LD E,(HL) 
	PUSH HL 
	CALL Lb75AD ; [30125]
	LD (HL),$89 
	POP HL 
	INC HL 
	INC HL 
	INC HL 
	INC HL 
	LD (HL),$00 
	LD HL,$75AB 
	INC (HL) 
	INC HL 
	INC (HL) 
	RET ; ==========================

Lb76F6:    ; <<< Uncharted Entry ]

	NOP 
Lb76F7:
	CP $01 ; [1]
	JP Z, Lb76A4 ; [30372]
	JP Lb7694 ; [30356]
Lb76FF:
	LD D,$0E 
Lb7701:
	NOP 
Lb7702:
	NOP 
Lb7703:
	CALL Lb75D4 ; [30164]
	LD A,(RAM_LAST_K) ; GET LAST-K
	CP $FF ; [255]
	JR NZ, Lb7722 ; [$7722:30498]
Lb770D:
	LD A,(Lb76FF) 
	CP $16 ; [22-"-"]
	JR NZ, Lb778C ; [$778C:30604]
Lb7714:
	LD A,($75A8) 
	INC A 
	CP $14 ; [20-"="]
	JR NZ, Lb771D ; [$771D:30493]
	XOR A 
Lb771D:
	LD ($75A8),A 
	RET ; ==========================

Lb7721: 
	NOP 
Lb7722:
	CP $F7 ; [247]
	JR Z, Lb7739 ; [$7739:30521]
	CP $EF ; [239]
	JR NZ, Lb770D ; [$770D:30477]
	LD A,(RAM_LAST_K+1) ; GET LAST-K
	CP $FD ; [253]
	JR Z, Lb778C ; [$778C:30604]
	CP $F7 ; [247]
	JR NZ, Lb770D ; [$770D:30477]
	LD D,$01 
	JR Lb7742 ; [$7742:30530]
Lb7739:
	LD A,(RAM_LAST_K+1) ; GET LAST-K
	CP $DF ; [223]
	JR NZ, Lb770D ; [$770D:30477]
	LD D,$FF 
Lb7742:
	LD A,(Lb76FF+1) 
	ADD A,D 
	CP $00 ; [0]
	JR Z, Lb7750 ; [$7750:30544]
	CP $1D ; [29-"1"]
	JR Z, Lb7750 ; [$7750:30544]
	JR Lb7752 ; [$7752:30546]
Lb7750:
	LD D,$00 
Lb7752:
	LD A,D 
	LD (Lb7701),A 
	LD HL, Lb76FF+1 
	LD C,(HL) 
	INC C 
	LD E,$16 
	CALL Lb75AD ; [30125]
	LD (HL),$00 
	INC E 
	DEC C 
	CALL Lb75AD ; [30125]
	LD (HL),$00 
	INC HL 
	INC HL 
	LD (HL),$00 
	LD HL, Lb76FF+1 
	LD A,(HL) 
	INC HL 
	ADD A,(HL) 
	DEC HL 
	LD (HL),A 
	LD C,A 
	DEC E 
	INC C 
	CALL Lb75AD ; [30125]
	LD (HL),$83 
	DEC C 
	INC E 
	CALL Lb75AD ; [30125]
	LD (HL),$02 
	INC HL 
	LD (HL),$B4 
	INC HL 
	LD (HL),$01 
	JR Lb7714 ; [$7714:30484]
Lb778C:
	LD HL, Lb76FF 
	LD A,(HL) 
	CP $16 ; [22-"-"]
	JR NZ, Lb779C ; [$779C:30620]
	LD (HL),$16 
	INC HL 
	LD A,(HL) 
	INC A 
	INC HL 
	INC HL 
	LD (HL),A 
Lb779C:
	LD A,(Lb76FF) 
	DEC A 
	LD (Lb76FF),A 
	LD E,A 
	LD A,(Lb7702) 
	LD C,A 
	CALL Lb75AD ; [30125]
	LD A,(HL) 
	CP $89 ; [137]
	JR Z, Lb77D2 ; [$77D2:30674]
	CP $34 ; [52-"O"]
	JR Z, Lb77DA ; [$77DA:30682]
	LD (HL),$17 
	LD A,$04 
Lb77B8:
	LD B,$FF 
Lb77BA:
	DJNZ Lb77BA ; [$77BA:30650]
	DEC A 
	CP $00 ; [0]
	JR NZ, Lb77B8 ; [$77B8:30648]
	LD (HL),$00 
	LD A,(Lb76FF) 
	CP $02 ; [2]
	JR NZ, Lb77CF ; [$77CF:30671]
Lb77CA:
	LD HL, Lb76FF 
	LD (HL),$16 
Lb77CF:
	JP Lb7714 ; [30484]
Lb77D2:
	LD (HL),$00 
	LD HL,$75AC 
	INC (HL) 
	JR Lb77CA ; [$77CA:30666]
Lb77DA:
	LD (HL),$89 
	CALL Lb77E8 ; [30696]
	LD HL,$75AC 
	INC (HL) 
	INC (HL) 
	DEC HL 
	INC (HL) 
	DEC DE 
.db $E2; DATA
Lb77E8:
	LD D,C 
	LD C,$14 
Lb77EB:
	LD HL,$7530 
	DEC C 
	LD A,C 
	CP $00 ; [0]
	JR Z, Lb7800 ; [$7800:30720]
	CP $FF ; [255]
	RET Z 
	LD B,C 
Lb77F8:
	INC HL 
	INC HL 
	INC HL 
	INC HL 
	INC HL 
	INC HL 
	DJNZ Lb77F8 ; [$77F8:30712]
Lb7800:
	LD A,D 
	CP (HL) 
	JR NZ, Lb77EB ; [$77EB:30699]
	INC HL 
	LD A,E 
	CP (HL) 
	JR NZ, Lb77EB ; [$77EB:30699]
	INC HL 
	INC HL 
	INC HL 
	INC HL 
	JP Lb78E1 ; [30945]
Lb7810: ; <- USR Basic Enty.
	LD HL,$7530 
	LD C,$0B 
	LD B,$14 
Lb7817:
	LD (HL),C 
	INC HL 
	SUB A 
	INC A 
	INC A 
	LD (HL),A 
	INC HL 
	DEC A 
	DEC A 
	DEC A 
	LD (HL),A 
	INC HL 
	INC A 
	LD (HL),A 
	INC HL 
	DEC A 
	LD (HL),A 
	INC HL 
	INC A 
	INC A 
	LD (HL),A 
	INC C 
	INC HL 
	DJNZ Lb7817 ; [$7817:30743]
	LD (HL),$00 
	INC HL 
	LD (HL),$00 
	INC HL 
	LD (HL),$00 
	INC HL 
	LD (HL),$00 
	INC HL 
	LD (HL),$00 
	RET ; ==========================

Lb783F:
	NOP 
Lb7840:
	NOP 
Lb7841:
	LD A,$1B 
	CALL STACK_A ; []*BIOS ROM*
	LD HL,(RAM_SEED) ; GET SEED
	LD B,H 
	LD C,L 
	CALL STACK_BC ; []*BIOS ROM*
	LD BC,$FFFF 
	CALL STACK_BC ; []*BIOS ROM*
	RST 28H 
.db	$05 ; RST28 Arg: Division CMD.
.db	$04 ; RST28 Arg: Multiply CMD.
	INC (HL) 
	CALL FIND_INT ; [FIND-INT]
	INC BC 
	INC BC 
	INC BC 
	LD B,$00 
	LD C,C 
	LD HL,(RAM_SEED) ; GET SEED
	LD D,H 
	LD E,L 
	ADD HL,HL 
	ADD HL,DE 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,DE 
	ADD HL,HL 
	ADD HL,DE 
	LD (RAM_SEED),HL ; SET SEED
	RET ; ==========================

Lb7871: ; <- USR Basic Enty.
	LD A,$02 
Lb7873:
	LD E,A 
	LD C,$00 
	CALL Lb75AD ; [30125]
	LD (HL),$89 
	LD C,$1F 
	CALL Lb75AD ; [30125]
	LD (HL),$89 
	INC A 
	CP $18 ; [24-"/"]
	JR NZ, Lb7873 ; [$7873:30835]
	LD HL, Lb783F 
	LD (HL),$03 
Lb788C:
	INC HL 
	LD (HL),$00 
Lb788F:
	CALL Lb7841 ; [30785]
	LD HL, Lb783F 
	LD E,(HL) 
	CALL Lb75AD ; [30125]
	LD (HL),$89 
	LD HL, Lb7840 
	INC (HL) 
	LD A,(HL) 
	CP $04 ; [4]
	JR NZ, Lb788F ; [$788F:30863]
	DEC HL 
	INC (HL) 
	INC (HL) 
	LD A,(HL) 
	CP $17 ; [23-"*"]
	JR NZ, Lb788C ; [$788C:30860]
	RET ; ==========================

Lb78AD: ; <- USR Basic Enty.
	LD HL,$75AB 
	LD A,(HL) 
	CP $14 ; [20-"="]
	JR NZ, Lb78BB ; [$78BB:30907]
	LD HL, Lb78AD 
	LD (HL),$01 
	RET ; ==========================

Lb78BB:
	LD HL,($75A9) 
	INC HL 
	LD A,(HL) 
	CP $16 ; [22-"-"]
	JR NZ, Lb78CA ; [$78CA:30922]
	LD HL, Lb78AD 
	LD (HL),$02 
	RET ; ==========================

Lb78CA:
	CALL Lb7703 ; [30467]
	LD A,(Lb76FF) 
	CP $16 ; [22-"-"]
	JR NZ, Lb78AD ; [$78AD:30893]
	LD A,$04 
Lb78D6:
	LD B,$FF 
Lb78D8:
	DJNZ Lb78D8 ; [$78D8:30936]
	DEC A 
	CP $00 ; [0]
	JR NZ, Lb78D6 ; [$78D6:30934]
	JR Lb78AD ; [$78AD:30893]
Lb78E1:
	LD A,(HL) 
	CP $00 ; [0]
	JP Z, Lb77EB ; [30699]
	LD (HL),$00 
	RET ; ==========================

;------------ Labels errors ------------
; LABEL @LB7700 Fixed: LD A,($7700) / LD A,(Lb76FF+1)

.end
